unit dbkf_main;
{*
 * Filename.....: dbkf_main.pas (dbknitofrontend)
 * Purpose......: Main module of DBFrontend
 *
 * Erstellt am..: Freitag, 6. Februar 2004, 16:40:59
 *       _  __      _ _
 *  ||| | |/ /     (_) |        Wirtschaftsinformatiker IHK
 * \. ./| ' / _ __  _| |_ ___   www.ingoknito.de
 * - ^ -|  < | '_ \| | __/ _ \
 * / - \| . \| | | | | || (_) | Peter Klauer
 *  ||| |_|\_\_| |_|_|\__\___/
 * mailto.......: knito@knito.de
 *
 * Changes:
 *}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, ComCtrls, JvPlacemnt, Mask, JvToolEdit, inifiles,
  mystring, FileCtrl, JvDriveCtrls, Buttons, JvEditor, JvSplitter,
  JvComponent, JvSplit, shellapi,JclFileUtils, JclStrings, JvLabel,
  JvAngleLabel, JvScrollBox,
  ImageDLLLoader, ICOLoader, JPEGLoader, PNGLOader, HIPSLoader, BMPLoader, PCXLoader, WMFLoader,
  LinarBitmap, Menus, ActnList, JvMaskEdit, JvSpin, JvTranslator, JvMenus,
  JvCreateShortCut, config_project, config_dosbox, XPMan, JvPanel,
  JvListBox, JvCtrls, about, history, JvAppEvent;


type
  TDBKF = class(TForm)
    StatusBar1: TStatusBar;
    JvFormStorage1: TJvFormStorage;
    ActionList1: TActionList;
    act_new: TAction;
    act_save: TAction;
    act_delete: TAction;
    act_start: TAction;
    act_refresh: TAction;
    act_opensection: TAction;
    act_exit: TAction;
    JvTranslator1: TJvTranslator;
    JvTranslatorStrings1: TJvTranslatorStrings;
    MainMenu: TJvMainMenu;
    menu_file: TMenuItem;
    menu_language: TMenuItem;
    item_new: TMenuItem;
    item_Delete: TMenuItem;
    item_run: TMenuItem;
    item_N1: TMenuItem;
    item_exit: TMenuItem;
    menu_view: TMenuItem;
    item_refresh: TMenuItem;
    menu_sections: TMenuItem;
    item_General: TMenuItem;
    N1: TMenuItem;
    act_shortcut: TAction;
    item_MakeShortcut: TMenuItem;
    menu_configuration: TMenuItem;
    item_DOSBoxSettings: TMenuItem;
    item_ProjectSettings: TMenuItem;
    menu_help: TMenuItem;
    item_about: TMenuItem;
    N2: TMenuItem;
    Image2: TImage;
    XPManifest1: TXPManifest;
    Panel1: TJvPanel;
    Image1: TImage;
    ListBox1: TJvListBox;
    FileListBox: TJvFileListBox;
    item_history: TMenuItem;
    act_history: TAction;
    JvAppEvents1: TJvAppEvents;
    procedure FormShow(Sender: TObject);
    procedure btn_new_projectClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure lbl_mypathClick(Sender: TObject);
    procedure Label4Click(Sender: TObject);
    procedure edit_PathToDosboxChange(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure btn_refreshlistboxClick(Sender: TObject);
    procedure btn_delete_projectClick(Sender: TObject);
    procedure btn_start_projectClick(Sender: TObject);
    procedure lbl_dosbox_sourcefourge_netClick(Sender: TObject);
    procedure lbl_projectpathClick(Sender: TObject);
    procedure edit_general_snapshotimageChange(Sender: TObject);
    procedure edit_general_projectnameChange(Sender: TObject);
    procedure cb_autosnapdirClick(Sender: TObject);
    procedure lbl_manualfileClick(Sender: TObject);
    procedure lbl_wwwClick(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure act_opensectionExecute(Sender: TObject);
    procedure act_exitExecute(Sender: TObject);
    procedure item_setlanguageClick(Sender: TObject);
    procedure act_shortcutExecute(Sender: TObject);
    procedure item_configscriptClick(Sender: TObject);
    procedure item_aboutClick(Sender: TObject);
    procedure item_DOSBoxSettingsClick(Sender: TObject);
    procedure act_historyExecute(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    procedure addtolistbox( s : string );
    procedure Status( s: string; s2 : string = '' );
    procedure readprojects;
    procedure readproject( projectname : string );
    function myreadbool( ini : tinifile; section, b : string ; default : boolean ) : boolean;
    procedure mywritebool( ini : tinifile; section, b : string; value : boolean );
    function StartProgram( const prog : string ) : boolean;
  end;

var
  DBKF: TDBKF;

  MyPath : string;
  MySnapDir : string;
  DosBoxPath : string;

  ini : tinifile;


  sdl_output : array[0..3] of string = ('surface', 'overlay', 'opengl', 'openglnb' );
  dosbox_machine : array[0..4] of string = ('auto','hercules','cga','tandy','vga' );
  render_scaler : array[0..2] of string = ('none', 'normal2x', 'advmame2x' );
  cpu_core : array[0..2] of string = ('normal', 'full', 'dynamic' );
  midi_device : array[0..5] of string =
    ('default','alsa','oss','win32','coreaudio','none');

implementation


{$R *.dfm}

procedure TDBKF.FormCreate(Sender: TObject);
begin

  mypath := extractfilepath( application.exename );

end;

procedure TDBKF.FormShow(Sender: TObject);
var
  filename : tfilename;
  lang_ini : tinifile;
  ts : tstringlist;
  i : integer;
  new_item : tmenuitem;
begin

  // Update JvFormStorage settings: load pathtodosbox.text
  frm_dosbox_config.show;

  // Show empty configuration window
  // hide it, if pathtodosbox is set
  if not empty( frm_dosbox_config.edit_PathToDosbox.Text ) then
    frm_dosbox_config.hide;

  frm_dosbox_config.cb_showhintsClick(sender);

  frm_project_config.edit_general_snapshotimage.Filter:='All images ('+BitmapLoaders.GetLoadFilter;

  filename := application.exename;

  frm_dosbox_config.edit_pathtodosbox.initialdir := frm_dosbox_config.edit_pathtodosbox.Text;
  frm_dosbox_config.lbl_mypath.Caption := mypath;

  filelistbox.directory := mypath;
  filelistbox.Update;

  readprojects;

  frm_project_config.pagecontrol.ActivePage := frm_project_config.ts_general;

  if VersionResourceAvailable(FileName) then
  begin
    with TJclFileVersionInfo.Create(FileName) do
    try

      frm_about.lbl_version.caption := BinFileVersion;
      frm_about.lbl_version.hint := 'DBFrontend version '+binfileversion;
      caption := 'DBFrontend '+BinFileVersion+' for DOSBox';

    finally
      Free;
    end;
  end;

  if frm_project_config.btn_readconfig.enabled then
  begin
    ts := tstringlist.create;

    lang_ini := tinifile.create( mypath+'\lang\lang.ini' );
    lang_ini.ReadSection('languages',ts);


    for i := 0 to (ts.count - 1) do
    begin

      new_item := tmenuitem.create( self );
      new_item.caption := ts[i];
      new_item.name := 'item_' + lang_ini.readstring( 'languages', ts[i], '' );
      new_item.onclick := item_setlanguageClick;
      new_item.GroupIndex := 1;
      new_item.RadioItem := true;
      new_item.tag := i;

      menu_language.add( new_item );

      if new_item.tag = menu_language.Tag then
      begin

        new_item.Checked := true;
        item_setlanguageClick( new_item );

      end;

    end;

    ts.free;
    lang_ini.free;

    frm_project_config.btn_readconfigClick( self );
    frm_project_config.btn_readconfig.enabled := false;
  end;

  // btn_new_projectclick( sender );

  if (listbox1.Tag > -1) and (listbox1.Tag < listbox1.Items.Count) then
  begin
    listbox1.ItemIndex := listbox1.tag;
    ListBox1Click( self );
  end;

  listbox1.SetFocus;
  // set language
  item_setlanguageClick(self);

  frm_project_config.pnl_project_config.ParentColor := false;
  frm_project_config.pnl_project_config.Color := clBlack;
  frm_project_config.pnl_project_config.update;  

  // force repainting:
  height := height -1;
  update;
  application.processmessages;
  height := height +1;
  update;
  application.processmessages;  
end;

procedure TDBKF.btn_new_projectClick(Sender: TObject);
var
  ini : tinifile;
begin

  listbox1.ItemIndex := -1;
  // edit_general_projectname.text := '';
  frm_project_config.edit_general_projectname.text := '';
  //
  // Set default values from dosbox.conf
  //
  ini := tinifile.create( nolastbackslash(frm_dosbox_config.edit_pathtodosbox.Text)+ '\dosbox.conf' );

  //readdata( ini );
  frm_project_config.readdata( ini );
  frm_project_config.pnl_project_config.Caption := 'New Project';

  mySnapDir := nolastbackslash(mypath) + '\snaps\';

  //frm_project_config.edit_render_snapdir.InitialDir := mySnapDir;
  tedit( frm_project_config.findcomponent('edit_render_snapdir')).text := mySnapDir;

  frm_project_config.edit_general_snapshotimage.initialdir := mySnapDir;
  frm_project_config.edit_general_snapshotimage.text := mySnapDir;

  frm_project_config.pagecontrol.activepage := frm_project_config.ts_general;

  frm_project_config.Show;

  frm_project_config.edit_general_Projectname.SetFocus;

  status('Project cleared.');

end;


procedure TDBKF.lbl_mypathClick(Sender: TObject);
var
  s : string;
begin
  s := nolastbackslash( MyPath );
  s := 'explorer.exe '+s+#0;
	winexec( @s[1], SW_SHOWNORMAL );
end;

procedure tDBKF.addtolistbox( s : string );
begin
  if listbox1.Items.IndexOf(s) = -1 then
  begin
    listbox1.Items.add( s );
  end;
end;

procedure TDBKF.Label4Click(Sender: TObject);
begin
  lbl_mypathclick(sender);
end;

procedure TDBKF.Status( s: string; s2 : string = '' );
var
  jetzt : string;
begin

  jetzt := timetostr( now );

  if empty( s2 ) then
    statusbar1.panels[0].text := jetzt + #9 + s
  else
    statusbar1.panels[0].text := jetzt + #9 + s2;

  frm_history.Memo_history.Lines.Add(jetzt + #9+ s);
end;


procedure TDBKF.edit_PathToDosboxChange(Sender: TObject);
begin
  if( frm_dosbox_config.edit_PathToDosbox.Text <> DosBoxPath ) then
  begin
    DosBoxPath := frm_dosbox_config.edit_PathToDosbox.Text;
    status('Path to dosbox changed to "'+DosBoxPath+'".');
  end;
end;

procedure tDBKF.readprojects;
var
  i,c : integer;
  s, projectname, oldproject : string;
  newindex : integer;

begin

  // read all ini-Files from current directory
  // Trick: They are all in the filelistbox component, which is invisible!

  newindex := -1;

  if listbox1.itemindex >= 0 then
  begin
    oldproject := frm_project_config.edit_general_projectname.text; // listbox1.Items[ listbox1.itemindex ];
  end else begin
    oldproject := '';
  end;

  // re-read the files into the listbox. Mask = .ini
  filelistbox.update;
  application.processmessages;
  sleep(100);

  c := filelistbox.Items.count;
  listbox1.Items.Clear;

  for i := 1 to c do
  begin
    s := filelistbox.items[i-1];
    projectname := copy( s, 1, length(s)-4 ); // no '.ini'
    listbox1.Items.add( projectname );
    if projectname = oldproject then newindex := i - 1;
  end;

  listbox1.update;
  application.processmessages;

  if newindex > -1 then listbox1.itemindex := newindex;

end;

procedure tDBKF.readproject( projectname : string );
var
  ini : tinifile;
begin
  ini := tinifile.create( mypath + projectname + '.ini' );

  //readdata( ini );
  frm_project_config.readdata( ini );

  frm_project_config.edit_general_projectname.text := projectname;
  frm_project_config.pnl_project_config.Caption := projectname;


  status('Project '+projectname+' loaded.');
end;

procedure TDBKF.ListBox1Click(Sender: TObject);
begin

  frm_project_config.edit_general_projectname.Text := listbox1.items[listbox1.itemindex];
  readproject( frm_project_config.edit_general_projectname.Text );
  listbox1.Tag := listbox1.ItemIndex;

end;

procedure TDBKF.btn_refreshlistboxClick(Sender: TObject);
begin

  readprojects;

end;

function tDBKF.myreadbool( ini : tinifile; section, b : string ; default : boolean ): boolean;
var
  s : string;
begin
  result := default;
  s := ini.ReadString(section,b,'');
  if s = 'false' then result := false;
  if s = 'true' then result := true;
end;

procedure tDBKF.mywritebool( ini : tinifile; section, b : string; value : boolean );
var
  s : string;
begin
  s := 'false';
  if value = true then s := 'true';
  ini.WriteString(section, b, s);
end;

procedure TDBKF.btn_delete_projectClick(Sender: TObject);
var
  p, s, dir : string;
begin
  if listbox1.ItemIndex < 0 then
  begin
    MessageDlg(
      'ERROR:'+#13+#10+
      'No project is selected in the project listbox!'+#13+#10+
      'Please click on a project name and try again!' +#13+#10+
      'Nothing is deleted.'+#13+#10+
      'Sorry.' , mtError, [mbOK], 0);
    exit;
  end;

  p := listbox1.items[listbox1.itemindex];
  if MessageDlg('Do you really want to delete'+#13+#10+'the project "'+p+'"?',
    mtConfirmation, [mbYes,mbNo], 0) = mrYes then
  begin

    s := mypath + p + '.ini' + #0;

    // delete snapshotfolder, when it is within the DBFrontend-directory
    if( fileexists( frm_project_config.edit_general_snapshotimage.FileName ) )
      and ( not directoryexists( frm_project_config.edit_general_snapshotimage.filename ) )
    then
      dir := extractfilepath( frm_project_config.edit_general_snapshotimage.FileName)
    else
      dir := frm_project_config.edit_general_snapshotimage.Text;

    // is dir a subdir of mypath?
    // mypath should be smaller, dir longer and mypath the beginning of dir

    if ( stricomp( pchar(mypath), pchar( copy(dir,1,length(mypath) ) ) ) = 0 )
    and (not empty( dir ) ) then

    begin

      // clear directory?
      if not RemoveDir( dir ) then
      begin
      MessageDlg(
        'Directory "'+dir+'" not removed.'+#13+#10+
        'Not empty?'+#13+#10+''+#13+#10+
        'Please remove it yourself.', mtWarning, [mbOK], 0);
      end;

    end;

    if deletefile( pchar( s ) ) then

      status( 'Project '+p+' deleted.')


    else

      status( 'ERROR when trying to delete '+s+'.' );

    readprojects;

  end;


end;

procedure TDBKF.btn_start_projectClick(Sender: TObject);
var
  nc, e, s : string;
begin

  if listbox1.ItemIndex < 0 then
  begin
    MessageDlg('No project is selected in the project listbox!'+#13+#10+'Please click on a project name and try again!', mtError, [mbOK], 0);
    exit;
  end;

  e := '';
  if frm_project_config.cb_general_exit.checked then e := ' -exit';

  nc := '';
  if frm_project_config.cb_general_noconsole.checked then nc := ' -noconsole';

  chdir( frm_dosbox_config.edit_pathtodosbox.text );

  s :=
    'dosbox.exe "' +
    frm_project_config.edit_general_projectdir.Text +'"'+
    e +
    ' -conf ' +
    '"'+MyPath +
    listbox1.items[listbox1.itemindex] +
    '.ini"' +
    nc +
    #0;

  status( s, 'Project ' + listbox1.items[listbox1.itemindex] + ' started.' );
	winexec( @s[1], SW_SHOWNORMAL );



end;

function TDBKF.StartProgram( const prog : string ) : boolean;
var
  dir, s : string;
begin

  dir := extractfilepath( prog )+#0;
  s := prog+#0;
  result := (shellexecute( application.handle, 'Open', @s[1], '', @dir[1], SW_SHOWNORMAL ) > 32);

end;

procedure TDBKF.lbl_dosbox_sourcefourge_netClick(Sender: TObject);
begin
  startprogram( tlabel( sender).caption );
end;

procedure TDBKF.lbl_projectpathClick(Sender: TObject);
var
  s : string;
begin

  s := 'explorer.exe '+ extractfilepath( frm_project_config.edit_general_projectdir.edittext )+#0;
	winexec( @s[1], SW_SHOWNORMAL );
end;

procedure TDBKF.edit_general_snapshotimageChange(Sender: TObject);
var
  width , height : integer;
begin

  if fileexists( frm_project_config.edit_general_snapshotimage.filename ) then
  begin
    try

    width := image1.Picture.Bitmap.Width;
    height := image1.picture.bitmap.height;


    image1.Picture.bitmap.Canvas.Brush.Style := bsSolid;
    image1.Picture.bitmap.Canvas.Brush.Color := clBlack;
    image1.Picture.Bitmap.Canvas.FillRect( rect( 0, 0, width, height) );
    image1.Picture.LoadFromFile( frm_project_config.edit_general_snapshotimage.filename );

    except
    end;
  end else
  begin
    image1.Picture.assign( image2.Picture );
    image1.update;
  end;


end;

procedure TDBKF.edit_general_projectnameChange(Sender: TObject);
var
  snapdir : string;
begin
  if( frm_dosbox_config.cb_autosnapdir.checked ) then
  begin
  
    snapdir := nolastbackslash(mypath) + '\snaps\'+frm_project_config.edit_general_Projectname.text;

    //edit_render_snapdir.InitialDir := snapdir;
    tedit(frm_project_config.findcomponent('edit_render_snapdir')).text := snapdir;

    frm_project_config.edit_general_snapshotimage.initialdir := snapdir;
    frm_project_config.edit_general_snapshotimage.text := snapdir;

  end;
end;

procedure TDBKF.cb_autosnapdirClick(Sender: TObject);
begin
  with tedit(frm_project_config.findcomponent('edit_render_snapdir')) do
  begin
    readonly := frm_dosbox_config.cb_autosnapdir.checked;
    Enabled := not frm_dosbox_config.cb_autosnapdir.checked;
  end;
end;

procedure TDBKF.lbl_manualfileClick(Sender: TObject);
begin
  startprogram( frm_project_config.edit_general_manualfile.text );
end;

procedure TDBKF.lbl_wwwClick(Sender: TObject);
begin
  startprogram( frm_project_config.edit_general_www.text );
end;

procedure TDBKF.FormKeyPress(Sender: TObject; var Key: Char);
begin
  case key of

    #10, #13: btn_start_projectClick(self);
    #4: btn_delete_projectClick(self);
    #14: btn_new_projectClick(self);

  end; 
end;

procedure TDBKF.act_opensectionExecute(Sender: TObject);
var
  s : string;
  i : integer;
begin

  s := TMenuItem( TAction( sender ).ActionComponent ).caption;

  // & ausfiltern!
  s := StrRemoveChars(s, ['&'] );

  for i := 0 to frm_project_config.pagecontrol.PageCount - 1 do
  begin

    if frm_project_config.pagecontrol.Pages[i].Caption = s then
    begin
      frm_project_config.PageControl.ActivePage := frm_project_config.pagecontrol.Pages[i];
      break;
    end;

  end;

  frm_project_config.show;  

end;

procedure TDBKF.act_exitExecute(Sender: TObject);
begin
  close;
end;

procedure TDBKF.item_setlanguageClick(Sender: TObject);
var
  transFileName, xmlfile : string;
  tm : tmenuitem;

begin

  if sender is tmenuitem then
  begin
    tm := tmenuitem( sender );
    tm.Checked := true;
    menu_language.Tag := tm.Tag;

    xmlfile := copy( tm.name, 6, length( tm.name ) - 5 );

    transFileName := mypath + 'lang\'+ xmlfile + '.xml';
    if not FileExists(transFileName) then
      MessageDlg('File not found: ' + transFileName, mtError, [mbOK], 0)
    else
      JvTranslator1.Translate(transFileName);

    MainMenu.refresh;

  end;

end;

procedure TDBKF.act_shortcutExecute(Sender: TObject);
var
  filename, parameters, e, nc : string;
  csc : TJvCreateShortcut;
begin

  if listbox1.ItemIndex < 0 then
  begin
    MessageDlg('No project is selected in the project listbox!'+#13+#10+'Please click on a project name and try again!', mtError, [mbOK], 0);
    exit;
  end;

  e := '';
  if frm_project_config.cb_general_exit.checked then e := ' -exit';

  nc := '';
  if frm_project_config.cb_general_noconsole.checked then nc := ' -noconsole';


  filename := nolastbackslash(frm_dosbox_config.edit_pathtodosbox.text)+'\dosbox.exe';
  parameters :=
    '"' +
    frm_project_config.edit_general_projectdir.Text +'"'+
    e +
    ' -conf ' +
    '"'+MyPath +
    listbox1.items[listbox1.itemindex] +
    '.ini"' +
    nc;

  csc := TJvCreateShortcut.Create( self );
  csc.CreateDesktopShortcut(
    filename,
    parameters,
    listbox1.items[listbox1.itemindex]);

  csc.free;

end;

procedure TDBKF.item_configscriptClick(Sender: TObject);
begin
  frm_project_config.show;
end;

procedure TDBKF.item_aboutClick(Sender: TObject);
begin
  frm_about.Show;
end;

procedure TDBKF.item_DOSBoxSettingsClick(Sender: TObject);
begin
  frm_dosbox_config.show;
end;

procedure TDBKF.act_historyExecute(Sender: TObject);
begin
  frm_history.show;
end;

end.
